svn commit: r326992 - head/sys/tools

Ed Maste emaste at FreeBSD.org
Tue Dec 19 19:44:08 UTC 2017


Author: emaste
Date: Tue Dec 19 19:44:06 2017
New Revision: 326992
URL: https://svnweb.freebsd.org/changeset/base/326992

Log:
  embed_mfs: support embedding mfs into loader
  
  The script originally supported embedding an mfs into ELF files or any
  other type of file, because it searched for magic strings to mark the
  beginning and end of the embeddable section. It was later modified to
  read the section offset and length via readelf, which made it work for
  ELF only. Restore the ability to update arbitrary file types by using
  the readelf technique for ELF, and the magic string technique for all
  others (including PE/COFF files like loader.efi).
  
  Submitted by:	Zakary Nafziger <worldofzak at gmail.com>
  MFC after:	1 month
  Sponsored by:	The FreeBSD Foundation
  Differential Revision:	https://reviews.freebsd.org/D12746

Modified:
  head/sys/tools/embed_mfs.sh

Modified: head/sys/tools/embed_mfs.sh
==============================================================================
--- head/sys/tools/embed_mfs.sh	Tue Dec 19 19:18:48 2017	(r326991)
+++ head/sys/tools/embed_mfs.sh	Tue Dec 19 19:44:06 2017	(r326992)
@@ -27,10 +27,10 @@
 #
 # $FreeBSD$ 
 #
-# Embed the MFS image into the kernel body (expects space reserved via 
-# MD_ROOT_SIZE)
+# Embed an MFS image into the kernel body or the loader body (expects space
+# reserved via MD_ROOT_SIZE (kernel) or MD_IMAGE_SIZE (loader))
 #
-# $1: kernel filename
+# $1: kernel or loader filename
 # $2: MFS image filename
 #
 
@@ -47,16 +47,39 @@ mfs_size=`stat -f '%z' $2 2> /dev/null`
 # If we can't determine MFS image size - bail.
 [ -z ${mfs_size} ] && echo "Can't determine MFS image size" && exit 1
 
-sec_info=`elfdump -c $1 2> /dev/null | grep -A 5 -E "sh_name: oldmfs$"`
-# If we can't find the mfs section within the given kernel - bail.
-[ -z "${sec_info}" ] && echo "Can't locate mfs section within $1" && exit 1
+err_no_mfs="Can't locate mfs section within "
 
-sec_size=`echo "${sec_info}" | awk '/sh_size/ {print $2}' 2> /dev/null`
-sec_start=`echo "${sec_info}" | awk '/sh_offset/ {print $2}' 2> /dev/null`
+if [ `file -b $1 | grep -q '^ELF ..-bit .SB executable'` ]; then
 
+	sec_info=`elfdump -c $1 2> /dev/null | grep -A 5 -E "sh_name: oldmfs$"`
+	# If we can't find the mfs section within the given kernel - bail.
+	[ -z "${sec_info}" ] && echo "${err_no_mfs} $1" && exit 1
+
+	sec_size=`echo "${sec_info}" | awk '/sh_size/ {print $2}' 2>/dev/null`
+	sec_start=`echo "${sec_info}" | \
+	    awk '/sh_offset/ {print $2}' 2>/dev/null`
+
+else
+
+	#try to find start byte of MFS start flag otherwise - bail.
+	sec_start=`strings -at d $1 | grep "MFS Filesystem goes here"` || \
+	    { echo "${err_no_mfs} $1"; exit 1; }
+	sec_start=`echo ${sec_start} | awk '{print $1}'`
+
+	#try to find start byte of MFS end flag otherwise - bail.
+	sec_end=`strings -at d $1 | \
+	    grep "MFS Filesystem had better STOP here"` || \
+	    { echo "${err_no_mfs} $1"; exit 1; }
+	sec_end=`echo ${sec_end} | awk '{print $1}'`
+
+	#calculate MFS section size
+	sec_size=`expr ${sec_end} - ${sec_start}`
+
+fi
+
 # If the mfs section size is smaller than the mfs image - bail.
 [ ${sec_size} -lt ${mfs_size} ] && echo "MFS image too large" && exit 1
 
 # Dump the mfs image into the mfs section
 dd if=$2 ibs=8192 of=$1 obs=${sec_start} oseek=1 conv=notrunc 2> /dev/null && \
-    echo "MFS image embedded into kernel" && exit 0
+    echo "MFS image embedded into $1" && exit 0


More information about the svn-src-all mailing list